; Many thanks to Chetnik for his method to load executables from memory

.386
.model flat, stdcall
option casemap:none

import		PROTO :DWORD,:DWORD
do_relocation	PROTO :DWORD,:DWORD,:DWORD
LoadEXEfromMem	PROTO :DWORD,:DWORD

include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc

.code

LoadEXEfromMem PROC pEXE:DWORD,pModule:DWORD

LOCAL exeptr:DWORD,nthdr:IMAGE_NT_HEADERS32,entry:DWORD

    mov esi,pEXE
    add esi, [esi+3ch]                    ;<--- go to PE...
; copy to nthdr struct
    lea edi,nthdr
    mov ecx, sizeof IMAGE_NT_HEADERS32
    cld 
    rep movsb                                
   
; Allocate memory for image --- random address we don't care...
; B/C we want to execute our code from any given location...

    invoke  VirtualAlloc, NULL, nthdr.OptionalHeader.SizeOfImage, \
            MEM_COMMIT, PAGE_EXECUTE_READWRITE
            
    or eax,eax
    jnz @f  ; return on failure
    mov ecx,pModule
    mov DWORD PTR [ecx],0
    ret

@@:

    mov exeptr, eax
   
    add eax, nthdr.OptionalHeader.AddressOfEntryPoint
    mov entry, eax              ;<---- Here is out new entry point =) 
                               
; Copy Headers to exeptr (our virtual-pe-exe =))

    mov esi, pEXE
    mov edi, exeptr
    mov ecx, nthdr.OptionalHeader.SizeOfHeaders
    cld
    rep movsb
   
    mov ebx,pEXE
    add ebx, [ebx+3ch]
    add ebx, sizeof IMAGE_NT_HEADERS32  ;<---ebx points to the first section struct
                                        ;<---copy all section to the right place in
                                        ;<--- virtual-exe
                                        
    ASSUME  ebx : ptr IMAGE_SECTION_HEADER                                    
   
    xor ecx, ecx                                    
    mov cx, nthdr.FileHeader.NumberOfSections

   ;<------- Copy all sections to memory

@@:
    mov esi, [ebx].PointerToRawData
    add esi,pEXE
    mov edi, [ebx].VirtualAddress
    add edi, exeptr
    push ecx
    mov ecx, [ebx].SizeOfRawData
    cld
    rep movsb
    pop ecx
    add ebx, sizeof IMAGE_SECTION_HEADER
    loop @B

;<--------- All sections are copied to right addresses
;<--------- Find import and Make adjustments
    mov ebx, nthdr.OptionalHeader.DataDirectory[1*8].VirtualAddress
    add ebx, exeptr
   
    invoke import, ebx,exeptr

;<---- IAT is ready to go, now we have to do relocations...
;<---- Yap nice and smooth relocations...

    mov ebx, nthdr.OptionalHeader.DataDirectory[5*8].VirtualAddress
    add ebx, exeptr       ;<------- Relocation Table...
   
    invoke  do_relocation, ebx,exeptr,ADDR nthdr
    mov eax,entry
    mov edx,exeptr
    mov ecx,pModule
    mov DWORD PTR [ecx],edx
    ret

LoadEXEfromMem ENDP

END